@if (vm$ | async; as vm) {
  <div [ngClass]="[jds.tablePaging]">
    <div [ngClass]="[jds.tableResponsive]">
      <table
        [ngClass]="[jds.table, jds.mb(0)]"
        role="table"
        aria-label="List Upload Change"
        aria-describedby="Table List Upload Change"
      >
        <thead>
          <tr>
            <th
              [style.width.%]="10"
              [colorScheme]="'gray'"
              [colorCustom]="true"
              [isFilterable]="true"
              scope="col"
              jdsBiTableHead
              column="type"
            >
              <span>Tipe Data</span>

              <div
                [style.cursor]="'pointer'"
                filter
                role="button"
              >
                <jds-bi-hosted-dropdown
                  [(open)]="isOpenTypeData"
                  [jdsBiDropdownLimitWidth]="'custom'"
                  [jdsBiDropdownMinWidth]="240"
                  [content]="dropdownTypeData"
                >
                  <i
                    class="tblhd-icon"
                    [ngClass]="['active']"
                  ></i>
                </jds-bi-hosted-dropdown>
              </div>
            </th>
            <th>Judul</th>
            @if (satudataUser.role_name === 'walidata') {
              <th [style.width.%]="15">Organisasi</th>
            }
            <th [style.width.%]="15">Pengunggah</th>
            <th
              [style.width.%]="14"
              [colorScheme]="'gray'"
              [colorCustom]="true"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              scope="col"
              jdsBiTableHead
              column="cdate"
            >
              Tanggal Submit
            </th>
            @if (
              vm.filterStatus !== 'verification' ||
              vm.filterStatusVerification !== 'new'
            ) {
              <th
                [style.width.%]="14"
                [colorScheme]="'gray'"
                [colorCustom]="true"
                [isSortable]="true"
                [currentSort]="{
                  sort: vm.filterSort,
                  direction: vm.filterDirection
                }"
                (filterSort)="onSort($event, vm.filterDirection)"
                scope="col"
                jdsBiTableHead
                column="mdate"
              >
                @switch (vm.filterStatus) {
                  @case ('verification') {
                    Tanggal Diubah
                  }
                  @case ('revision') {
                    Tanggal Verifikasi
                  }
                  @case ('approve') {
                    Tanggal Disetujui
                  }
                }
              </th>
            }
            <th
              [ngClass]="[jds.textAlign('center')]"
              [style.width.%]="10"
              scope="row"
            >
              Aksi
            </th>
          </tr>
        </thead>
        <tbody>
          @if (vm.listDeskCatalog; as listDesk) {
            @switch (listDesk.status) {
              @case ('loading') {
                <ng-container *ngTemplateOutlet="loading" />
              }

              @case ('success') {
                @if (listDesk.isFetching) {
                  <ng-container *ngTemplateOutlet="loading" />
                } @else if (listDesk.data.list.length > 0) {
                  @for (row of listDesk.data.list; track row.id) {
                    <tr>
                      <td>
                        @switch (row.type) {
                          @case ('dataset') {
                            <span
                              [colorScheme]="'purple'"
                              [variant]="'subtle'"
                              [isRounded]="true"
                              jdsBiBadge
                            >
                              Dataset
                            </span>
                          }
                          @case ('mapset') {
                            <span
                              [colorScheme]="'red'"
                              [variant]="'subtle'"
                              [isRounded]="true"
                              jdsBiBadge
                            >
                              Mapset
                            </span>
                          }
                          @case ('indicator') {
                            <span
                              [colorScheme]="'yellow'"
                              [variant]="'subtle'"
                              [isRounded]="true"
                              jdsBiBadge
                            >
                              Indikator
                            </span>
                          }
                        }
                      </td>
                      <td>
                        <a
                          [ngClass]="[jds.text('gray900')]"
                          [routerLink]="[
                            '/' + row.type + '/detail',
                            row.type_id
                          ]"
                        >
                          {{ row.name }}
                        </a>
                      </td>
                      @if (satudataUser.role_name === 'walidata') {
                        <td>
                          {{ row.nama_skpd_alias }}
                        </td>
                      }
                      <td>{{ row.username }}</td>
                      <td>{{ moment(row.cdate).format('DD/MM/YYYY') }}</td>
                      @if (
                        vm.filterStatus !== 'verification' ||
                        vm.filterStatusVerification !== 'new'
                      ) {
                        <td>
                          {{ moment(row.mdate).format('DD/MM/YYYY') }}
                        </td>
                      }
                      <td [ngClass]="[jds.textAlign('center')]">
                        <div [ngClass]="[jds.d('flex'), jds.gap(4)]">
                          @switch (satudataUser.role_name) {
                            @case ('walidata') {
                              @switch (vm.filterStatus) {
                                @case ('verification') {
                                  <ng-container
                                    [ngTemplateOutlet]="buttonCheck"
                                    [ngTemplateOutletContext]="{
                                      isFull: false,
                                      catalog: row.type,
                                      id: row.type_id
                                    }"
                                  />

                                  <ng-container
                                    [ngTemplateOutlet]="buttonTracking"
                                    [ngTemplateOutletContext]="{
                                      isFull: false,
                                      catalog: row.type,
                                      id: row.type_id
                                    }"
                                  />
                                }
                                @case ('revision') {
                                  <ng-container
                                    [ngTemplateOutlet]="buttonTracking"
                                    [ngTemplateOutletContext]="{
                                      isFull: false,
                                      catalog: row.type,
                                      id: row.type_id
                                    }"
                                  />

                                  <ng-container
                                    [ngTemplateOutlet]="buttonEdit"
                                    [ngTemplateOutletContext]="{
                                      isFull: false,
                                      catalog: row.type,
                                      id: row.type_id,
                                      category: row.history_draft.category
                                    }"
                                  />

                                  <ng-container
                                    [ngTemplateOutlet]="buttonDelete"
                                    [ngTemplateOutletContext]="{
                                      isFull: false,
                                      catalog: row.type,
                                      id: row.type_id,
                                      category: 'delete-active'
                                    }"
                                  />
                                }
                                @case ('approve') {
                                  <ng-container
                                    [ngTemplateOutlet]="buttonTracking"
                                    [ngTemplateOutletContext]="{
                                      isFull: true,
                                      catalog: row.type,
                                      id: row.type_id
                                    }"
                                  />
                                }
                              }
                            }
                            @case ('opd') {
                              @if (
                                vm.filterStatus === 'verification' ||
                                vm.filterStatus === 'revision'
                              ) {
                                <ng-container
                                  [ngTemplateOutlet]="buttonTracking"
                                  [ngTemplateOutletContext]="{
                                    isFull: false,
                                    catalog: row.type,
                                    id: row.type_id
                                  }"
                                />

                                <ng-container
                                  [ngTemplateOutlet]="buttonEdit"
                                  [ngTemplateOutletContext]="{
                                    isFull: false,
                                    catalog: row.type,
                                    id: row.type_id,
                                    category: row.history_draft.category
                                  }"
                                />
                              } @else if (vm.filterStatus === 'approve') {
                                <ng-container
                                  [ngTemplateOutlet]="buttonTracking"
                                  [ngTemplateOutletContext]="{
                                    isFull: true,
                                    catalog: row.type,
                                    id: row.type_id
                                  }"
                                />
                              }
                            }
                          }
                        </div>
                      </td>
                    </tr>
                  }
                } @else {
                  <ng-container *ngTemplateOutlet="empty" />
                }
              }

              @case ('error') {
                <ng-container *ngTemplateOutlet="error" />
              }
            }
          }
        </tbody>
      </table>
    </div>

    @if (vm.listDeskCatalog; as listDesk) {
      @if (listDesk.status === 'success') {
        @if (listDesk.data.list.length > 0) {
          <jds-bi-pagination
            [colorScheme]="colorScheme"
            [perPageItems]="perPageItems"
            [pagination]="listDesk.data.pagination"
            [perPage]="vm.filterPerPage"
            [page]="vm.filterCurrentPage"
            (filterPerPage)="onPerPage($event)"
            (filterPage)="onPage($event)"
          />
        }
      }
    }
  </div>

  <app-modal-dataset-tracking [historyData]="vm.historyDataset" />
  <app-modal-mapset-tracking [historyData]="vm.historyMapset" />
  <app-modal-indicator-tracking [historyData]="vm.historyIndicator" />

  <ng-template #dropdownTypeData>
    <div [ngClass]="[jds.px(16), jds.pt(12), jds.pb(8)]">
      <ul
        [ngClass]="[jds.ps(0), jds.mb(0)]"
        [style.listStyle]="'none'"
        [style.height]="'auto'"
      >
        @for (type of typeOptions; track $index) {
          <li [ngClass]="[jds.mb(5), jds.pe(15)]">
            <div [ngClass]="[jds.formCheck]">
              <input
                id="checkbox-type-{{ type.value }}"
                [(ngModel)]="type.checked"
                [ngClass]="[jds.formCheckInput]"
                (change)="onFilter(type.value, $event.target.checked)"
                type="checkbox"
              />
              <label
                [ngClass]="[jds.formCheckLabel]"
                for="checkbox-type-{{ type.value }}"
              >
                {{ type.label }}
              </label>
            </div>
          </li>
        }
      </ul>
    </div>
  </ng-template>

  <ng-template #loading>
    @for (i of [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]; track $index) {
      <tr>
        @switch (vm.filterStatus) {
          @case ('verification') {
            @for (
              j of getSkeleton(vm.filterStatusVerification).draft;
              track $index
            ) {
              <td>
                <ng-container *ngTemplateOutlet="skeleton" />
              </td>
            }
          }
          @case ('revision') {
            @for (
              j of getSkeleton(vm.filterStatusVerification).revision;
              track $index
            ) {
              <td>
                <ng-container *ngTemplateOutlet="skeleton" />
              </td>
            }
          }
          @case ('approve') {
            @for (
              j of getSkeleton(vm.filterStatusVerification).approve;
              track $index
            ) {
              <td>
                <ng-container *ngTemplateOutlet="skeleton" />
              </td>
            }
          }
        }
      </tr>
    }
  </ng-template>

  <ng-template #empty>
    <tr>
      @switch (vm.filterStatus) {
        @case ('verification') {
          <td
            [attr.colspan]="
              getSkeleton(vm.filterStatusVerification).draft.length
            "
            [ngClass]="[jds.textAlign('center')]"
          >
            Tidak ada Data.
          </td>
        }
        @case ('revision') {
          <td
            [attr.colspan]="
              getSkeleton(vm.filterStatusVerification).revision.length
            "
            [ngClass]="[jds.textAlign('center')]"
          >
            Tidak ada Data.
          </td>
        }
        @case ('approve') {
          <td
            [attr.colspan]="
              getSkeleton(vm.filterStatusVerification).approve.length
            "
            [ngClass]="[jds.textAlign('center')]"
          >
            Tidak ada Data.
          </td>
        }
      }
    </tr>
  </ng-template>

  <ng-template #error>
    <tr>
      @switch (vm.filterStatus) {
        @case ('verification') {
          <td
            [attr.colspan]="
              getSkeleton(vm.filterStatusVerification).draft.length
            "
            [ngClass]="[jds.textAlign('center')]"
          >
            Terjadi kesalahan.
          </td>
        }
        @case ('approve') {
          <td
            [attr.colspan]="
              getSkeleton(vm.filterStatusVerification).approve.length
            "
            [ngClass]="[jds.textAlign('center')]"
          >
            Terjadi kesalahan.
          </td>
        }
      }
    </tr>
  </ng-template>

  <ng-template #skeleton>
    <div class="wrapper-skeleton">
      <ngx-skeleton-loader
        [theme]="{
          width: '80%',
          'border-radius': '0',
          height: '22px',
          'margin-bottom': '0px'
        }"
      />
    </div>
  </ng-template>

  <ng-template
    #buttonCheck
    let-isFull="isFull"
    let-catalog="catalog"
    let-id="id"
  >
    <a
      [ngClass]="[
        jds.button,
        jds.buttonCustom('#42A5F5'),
        jds.text('white'),
        isFull ? jds.w('full') : ''
      ]"
      [routerLink]="['/' + catalog + '/detail', id]"
    >
      Periksa
    </a>
  </ng-template>

  <ng-template
    #buttonTracking
    let-isFull="isFull"
    let-catalog="catalog"
    let-id="id"
  >
    <button
      [ngClass]="[isFull ? jds.w('full') : '']"
      [colorScheme]="'blue'"
      (click)="onTracking(catalog, id)"
      jdsBiButton
    >
      Lacak
    </button>
  </ng-template>

  <ng-template
    #buttonEdit
    let-isFull="isFull"
    let-catalog="catalog"
    let-id="id"
    let-category="category"
  >
    <a
      [ngClass]="[isFull ? jds.w('full') : '']"
      [colorScheme]="'yellow'"
      [variant]="'ghost'"
      [isIconOnly]="true"
      [routerLink]="['/my-' + catalog + '/edit', id]"
      [queryParams]="getEditQueryParams(catalog, category)"
      jdsBiButton
    >
      <jds-bi-icon name="pencil" />
    </a>
  </ng-template>

  <ng-template
    #buttonDelete
    let-isFull="isFull"
    let-catalog="catalog"
    let-id="id"
    let-category="category"
  >
    <button
      [ngClass]="[isFull ? jds.w('full') : '']"
      [colorScheme]="'red'"
      [variant]="'ghost'"
      [isIconOnly]="true"
      (click)="onDelete(catalog, id, category)"
      jdsBiButton
    >
      <jds-bi-icon name="trash" />
    </button>
  </ng-template>
}
